import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#display_name ConditionalAccessPolicy#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#state ConditionalAccessPolicy#state}.
     *
     * @stability stable
     */
    readonly state: string;
    /**
     * conditions block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#conditions ConditionalAccessPolicy#conditions}
     *
     * @stability stable
     */
    readonly conditions: ConditionalAccessPolicyConditions[];
    /**
     * grant_controls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#grant_controls ConditionalAccessPolicy#grant_controls}
     *
     * @stability stable
     */
    readonly grantControls: ConditionalAccessPolicyGrantControls[];
    /**
     * session_controls block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#session_controls ConditionalAccessPolicy#session_controls}
     *
     * @stability stable
     */
    readonly sessionControls?: ConditionalAccessPolicySessionControls[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#timeouts ConditionalAccessPolicy#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: ConditionalAccessPolicyTimeouts;
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyConditionsApplications {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#excluded_applications ConditionalAccessPolicy#excluded_applications}.
     *
     * @stability stable
     */
    readonly excludedApplications?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_applications ConditionalAccessPolicy#included_applications}.
     *
     * @stability stable
     */
    readonly includedApplications: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_user_actions ConditionalAccessPolicy#included_user_actions}.
     *
     * @stability stable
     */
    readonly includedUserActions?: string[];
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyConditionsLocations {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#excluded_locations ConditionalAccessPolicy#excluded_locations}.
     *
     * @stability stable
     */
    readonly excludedLocations?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_locations ConditionalAccessPolicy#included_locations}.
     *
     * @stability stable
     */
    readonly includedLocations: string[];
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyConditionsPlatforms {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#excluded_platforms ConditionalAccessPolicy#excluded_platforms}.
     *
     * @stability stable
     */
    readonly excludedPlatforms?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_platforms ConditionalAccessPolicy#included_platforms}.
     *
     * @stability stable
     */
    readonly includedPlatforms: string[];
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyConditionsUsers {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#excluded_groups ConditionalAccessPolicy#excluded_groups}.
     *
     * @stability stable
     */
    readonly excludedGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#excluded_roles ConditionalAccessPolicy#excluded_roles}.
     *
     * @stability stable
     */
    readonly excludedRoles?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#excluded_users ConditionalAccessPolicy#excluded_users}.
     *
     * @stability stable
     */
    readonly excludedUsers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_groups ConditionalAccessPolicy#included_groups}.
     *
     * @stability stable
     */
    readonly includedGroups?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_roles ConditionalAccessPolicy#included_roles}.
     *
     * @stability stable
     */
    readonly includedRoles?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#included_users ConditionalAccessPolicy#included_users}.
     *
     * @stability stable
     */
    readonly includedUsers?: string[];
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyConditions {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#client_app_types ConditionalAccessPolicy#client_app_types}.
     *
     * @stability stable
     */
    readonly clientAppTypes: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#sign_in_risk_levels ConditionalAccessPolicy#sign_in_risk_levels}.
     *
     * @stability stable
     */
    readonly signInRiskLevels?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#user_risk_levels ConditionalAccessPolicy#user_risk_levels}.
     *
     * @stability stable
     */
    readonly userRiskLevels?: string[];
    /**
     * applications block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#applications ConditionalAccessPolicy#applications}
     *
     * @stability stable
     */
    readonly applications: ConditionalAccessPolicyConditionsApplications[];
    /**
     * locations block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#locations ConditionalAccessPolicy#locations}
     *
     * @stability stable
     */
    readonly locations: ConditionalAccessPolicyConditionsLocations[];
    /**
     * platforms block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#platforms ConditionalAccessPolicy#platforms}
     *
     * @stability stable
     */
    readonly platforms: ConditionalAccessPolicyConditionsPlatforms[];
    /**
     * users block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#users ConditionalAccessPolicy#users}
     *
     * @stability stable
     */
    readonly users: ConditionalAccessPolicyConditionsUsers[];
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyGrantControls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#built_in_controls ConditionalAccessPolicy#built_in_controls}.
     *
     * @stability stable
     */
    readonly builtInControls: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#custom_authentication_factors ConditionalAccessPolicy#custom_authentication_factors}.
     *
     * @stability stable
     */
    readonly customAuthenticationFactors?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#operator ConditionalAccessPolicy#operator}.
     *
     * @stability stable
     */
    readonly operator: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#terms_of_use ConditionalAccessPolicy#terms_of_use}.
     *
     * @stability stable
     */
    readonly termsOfUse?: string[];
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicySessionControls {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#application_enforced_restrictions_enabled ConditionalAccessPolicy#application_enforced_restrictions_enabled}.
     *
     * @stability stable
     */
    readonly applicationEnforcedRestrictionsEnabled?: boolean | cdktf.IResolvable;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#cloud_app_security_policy ConditionalAccessPolicy#cloud_app_security_policy}.
     *
     * @stability stable
     */
    readonly cloudAppSecurityPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#sign_in_frequency ConditionalAccessPolicy#sign_in_frequency}.
     *
     * @stability stable
     */
    readonly signInFrequency?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#sign_in_frequency_period ConditionalAccessPolicy#sign_in_frequency_period}.
     *
     * @stability stable
     */
    readonly signInFrequencyPeriod?: string;
}
/**
 * @stability stable
 */
export interface ConditionalAccessPolicyTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#create ConditionalAccessPolicy#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#delete ConditionalAccessPolicy#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#read ConditionalAccessPolicy#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html#update ConditionalAccessPolicy#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html azuread_conditional_access_policy}.
 *
 * @stability stable
 */
export declare class ConditionalAccessPolicy extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azuread/r/conditional_access_policy.html azuread_conditional_access_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: ConditionalAccessPolicyConfig);
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _state;
    /**
     * @stability stable
     */
    get state(): string;
    /**
     * @stability stable
     */
    set state(value: string);
    /**
     * @stability stable
     */
    get stateInput(): string;
    private _conditions;
    /**
     * @stability stable
     */
    get conditions(): ConditionalAccessPolicyConditions[];
    /**
     * @stability stable
     */
    set conditions(value: ConditionalAccessPolicyConditions[]);
    /**
     * @stability stable
     */
    get conditionsInput(): ConditionalAccessPolicyConditions[];
    private _grantControls;
    /**
     * @stability stable
     */
    get grantControls(): ConditionalAccessPolicyGrantControls[];
    /**
     * @stability stable
     */
    set grantControls(value: ConditionalAccessPolicyGrantControls[]);
    /**
     * @stability stable
     */
    get grantControlsInput(): ConditionalAccessPolicyGrantControls[];
    private _sessionControls?;
    /**
     * @stability stable
     */
    get sessionControls(): ConditionalAccessPolicySessionControls[];
    /**
     * @stability stable
     */
    set sessionControls(value: ConditionalAccessPolicySessionControls[]);
    /**
     * @stability stable
     */
    resetSessionControls(): void;
    /**
     * @stability stable
     */
    get sessionControlsInput(): ConditionalAccessPolicySessionControls[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): ConditionalAccessPolicyTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: ConditionalAccessPolicyTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): ConditionalAccessPolicyTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
