import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface NamedLocationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#display_name NamedLocation#display_name}.
     *
     * @stability stable
     */
    readonly displayName: string;
    /**
     * country block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#country NamedLocation#country}
     *
     * @stability stable
     */
    readonly country?: NamedLocationCountry[];
    /**
     * ip block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#ip NamedLocation#ip}
     *
     * @stability stable
     */
    readonly ip?: NamedLocationIp[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#timeouts NamedLocation#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: NamedLocationTimeouts;
}
/**
 * @stability stable
 */
export interface NamedLocationCountry {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#countries_and_regions NamedLocation#countries_and_regions}.
     *
     * @stability stable
     */
    readonly countriesAndRegions: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#include_unknown_countries_and_regions NamedLocation#include_unknown_countries_and_regions}.
     *
     * @stability stable
     */
    readonly includeUnknownCountriesAndRegions?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface NamedLocationIp {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#ip_ranges NamedLocation#ip_ranges}.
     *
     * @stability stable
     */
    readonly ipRanges: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#trusted NamedLocation#trusted}.
     *
     * @stability stable
     */
    readonly trusted?: boolean | cdktf.IResolvable;
}
/**
 * @stability stable
 */
export interface NamedLocationTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#create NamedLocation#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#delete NamedLocation#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#read NamedLocation#read}.
     *
     * @stability stable
     */
    readonly read?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html#update NamedLocation#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html azuread_named_location}.
 *
 * @stability stable
 */
export declare class NamedLocation extends cdktf.TerraformResource {
    /**
     * @stability stable
     */
    static readonly tfResourceType: string;
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/azuread/r/named_location.html azuread_named_location} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: NamedLocationConfig);
    private _displayName;
    /**
     * @stability stable
     */
    get displayName(): string;
    /**
     * @stability stable
     */
    set displayName(value: string);
    /**
     * @stability stable
     */
    get displayNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    private _country?;
    /**
     * @stability stable
     */
    get country(): NamedLocationCountry[];
    /**
     * @stability stable
     */
    set country(value: NamedLocationCountry[]);
    /**
     * @stability stable
     */
    resetCountry(): void;
    /**
     * @stability stable
     */
    get countryInput(): NamedLocationCountry[] | undefined;
    private _ip?;
    /**
     * @stability stable
     */
    get ip(): NamedLocationIp[];
    /**
     * @stability stable
     */
    set ip(value: NamedLocationIp[]);
    /**
     * @stability stable
     */
    resetIp(): void;
    /**
     * @stability stable
     */
    get ipInput(): NamedLocationIp[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): NamedLocationTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: NamedLocationTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): NamedLocationTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
